Attribute VB_Name = "PrecisionID_EANUPC_Module"

'###################################################################
'#  VBA Module for PrecisionID.com Fonts V2018
'#  Copyright, PrecisionID 2018. All rights reserved.
'#
'#  You may incorporate this Source Code in your application
'#  only if you own a valid license from PrecisionID.com
'#  for the associated font and this copyright notice is not removed.
'#
'#  Distributing our source code or fonts outside your
'#  organization requires a Developer or Redistribution License.
'#
'###################################################################

Private Text_Input As String
Private Text_Raw As String
Private End_Sequence As String
Private Start_Code As String
Private Stop_Code As String
Private F As Integer
Private Text_Output As String
Private Correct_Text As String
Private Printable_Text As String
Private Enc_Method As String
Private PreCheckTotal As Long
Private PreCheckVal As Integer
Private Current_Val As Long
Private Check_Val As Integer
Private Switch As Integer
Private I As Integer
Private Check_Digit As Integer
Private Current_Method As String
Private New_Line As String
Private This_Char As String
Private This_CharNum As Integer
Private Lead_Char As Integer
Private AddOn_2 As String
Private AddOn_5 As String
Private AddOn_TextFinal As String
Private HR_Text As String
Private Text_Len As Integer
Private FNC_Int As Integer


Public Function PrecisionID_UPC_A(Text_Input As String) As String
     End_Sequence = "  "
     Text_Output = ""
     Text_Input = RTrim(LTrim(Text_Input))
     Correct_Text = ""
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
          If IsNumeric(Mid(Text_Input, I, 1)) Then Correct_Text = Correct_Text & Mid(Text_Input, I, 1)
     Next I
     If Len(Correct_Text) < "11" Then Correct_Text = "00000000000"
     If Len(Correct_Text) = "15" Then Correct_Text = "00000000000"
     If Len(Correct_Text) > "18" Then Correct_Text = "00000000000"
     If Len(Correct_Text) = "12" Then Correct_Text = Mid(Correct_Text, 1, 11)
     If Len(Correct_Text) = "14" Then Correct_Text = (Mid(Correct_Text, 1, 11) & Mid(Correct_Text, 13, 2))
     If Len(Correct_Text) = "17" Then Correct_Text = (Mid(Correct_Text, 1, 11) & Mid(Correct_Text, 13, 5))
     AddOn_2 = ""
     AddOn_5 = ""
     AddOn_TextFinal = ""
     If Len(Correct_Text) = 16 Then AddOn_5 = Mid(Correct_Text, 12, 5)
     If Len(Correct_Text) = 13 Then AddOn_2 = Mid(Correct_Text, 12, 2)

     Text_Input = Mid(Correct_Text, 1, 11)
     Switch = 3
     PreCheckTotal = 0
     For I = Len(Text_Input) To 1 Step -1
          This_CharNum = Mid(Text_Input, I, 1)
          PreCheckTotal = PreCheckTotal + This_CharNum * Switch
          Switch = 4 - Switch
     Next I
     I = (PreCheckTotal Mod 10)
     If I <> 0 Then
          Check_Digit = (10 - I)
     Else
          Check_Digit = 0
     End If
     Text_Input = Text_Input & Check_Digit
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
          This_CharNum = AscW(Mid(Text_Input, I, 1))
          Select Case I
          Case 1
               If ChrW(This_CharNum) > 4 Then Text_Output = ChrW(This_CharNum + 64) & "(" & ChrW(This_CharNum + 49)
               If ChrW(This_CharNum) < 5 Then Text_Output = ChrW(This_CharNum + 37) & "(" & ChrW(This_CharNum + 49)
          Case 2
               Text_Output = Text_Output & ChrW(This_CharNum)
          Case 3
               Text_Output = Text_Output & ChrW(This_CharNum)
          Case 4
               Text_Output = Text_Output & ChrW(This_CharNum)
          Case 5
               Text_Output = Text_Output & ChrW(This_CharNum)
          Case 6
               Text_Output = Text_Output & ChrW(This_CharNum) & "*"
          Case 7
               Text_Output = Text_Output & ChrW(This_CharNum + 27)
          Case 8
               Text_Output = Text_Output & ChrW(This_CharNum + 27)
          Case 9
               Text_Output = Text_Output & ChrW(This_CharNum + 27)
          Case 10
               Text_Output = Text_Output & ChrW(This_CharNum + 27)
          Case 11
               Text_Output = Text_Output & ChrW(This_CharNum + 27)
          Case 12
               If ChrW(This_CharNum) > 4 Then Text_Output = Text_Output & ChrW(This_CharNum + 59) & "(" & ChrW(This_CharNum + 64)
               If ChrW(This_CharNum) < 5 Then Text_Output = Text_Output & ChrW(This_CharNum + 59) & "(" & ChrW(This_CharNum + 37)
          End Select
     Next I
     If Len(AddOn_5) = 5 Then
          AddOn_TextFinal = ""
          Switch = 3
          PreCheckTotal = 0
          For I = Len(AddOn_5) To 1 Step -1
               This_CharNum = Mid(AddOn_5, I, 1)
               If Switch = 3 Then PreCheckTotal = PreCheckTotal + This_CharNum * 3
               If Switch = 1 Then PreCheckTotal = PreCheckTotal + This_CharNum * 9
               Switch = 4 - Switch
          Next I
          Check_Digit = Val(Right$(PreCheckTotal, 1))
          Select Case Check_Digit
          Case 0
               Enc_Method = "BBAAA"
          Case 1
               Enc_Method = "BABAA"
          Case 2
               Enc_Method = "BAABA"
          Case 3
               Enc_Method = "BAAAB"
          Case 4
               Enc_Method = "ABBAA"
          Case 5
               Enc_Method = "AABBA"
          Case 6
               Enc_Method = "AAABB"
          Case 7
               Enc_Method = "ABABA"
          Case 8
               Enc_Method = "ABAAB"
          Case 9
               Enc_Method = "AABAB"
          End Select
          For I = 1 To Len(AddOn_5)
               This_Char = Mid(AddOn_5, I, 1)
               Current_Method = Mid(Enc_Method, I, 1)
               Select Case Current_Method
               Case "A"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(34)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(35)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(36)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(37)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(38)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(44)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(46)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(47)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(58)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(59)
               Case "B"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(122)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(61)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(63)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(64)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(91)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(92)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(93)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(95)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(123)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(125)
               End Select
               Select Case I
               Case 1
                    AddOn_TextFinal = ChrW(43) & AddOn_TextFinal & ChrW(33)
               Case 2
                    AddOn_TextFinal = AddOn_TextFinal & ChrW(33)
               Case 3
                    AddOn_TextFinal = AddOn_TextFinal & ChrW(33)
               Case 4
                    AddOn_TextFinal = AddOn_TextFinal & ChrW(33)
               Case 5
                    AddOn_TextFinal = AddOn_TextFinal
               End Select
          Next I
     End If
     If Len(AddOn_2) = 2 Then
          AddOn_TextFinal = ""
          For I = 0 To 99 Step 4
               If Val(AddOn_2) = I Then Enc_Method = "AA"
               If Val(AddOn_2) = I + 1 Then Enc_Method = "AB"
               If Val(AddOn_2) = I + 2 Then Enc_Method = "BA"
               If Val(AddOn_2) = I + 3 Then Enc_Method = "BB"
          Next I
          For I = 1 To Len(AddOn_2)
               This_Char = Mid(AddOn_2, I, 1)
               Current_Method = Mid(Enc_Method, I, 1)
               Select Case Current_Method
               Case "A"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(34)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(35)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(36)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(37)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(38)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(44)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(46)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(47)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(58)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(59)
               Case "B"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(122)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(61)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(63)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(64)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(91)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(92)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(93)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(95)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(123)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(125)
               End Select
               Select Case I
               Case 1
                    AddOn_TextFinal = ChrW(43) & AddOn_TextFinal & ChrW(33)
               Case 2
                    AddOn_TextFinal = AddOn_TextFinal
               End Select
          Next I
     End If
     PrecisionID_UPC_A = Text_Output & AddOn_TextFinal & End_Sequence
End Function

Public Function PrecisionID_UPC_E(Text_Input As String) As String
     End_Sequence = "  "
     Text_Input = RTrim(LTrim(Text_Input))
     Text_Output = ""
     Correct_Text = ""
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
          If IsNumeric(Mid(Text_Input, I, 1)) Then Correct_Text = Correct_Text & Mid(Text_Input, I, 1)
     Next I
     If Len(Correct_Text) < "11" Then Correct_Text = "00005000000"
     If Len(Correct_Text) = "15" Then Correct_Text = "00005000000"
     If Len(Correct_Text) > "18" Then Correct_Text = "00005000000"
     If Len(Correct_Text) = "12" Then Correct_Text = Mid(Correct_Text, 1, 11)
     If Len(Correct_Text) = "14" Then Correct_Text = (Mid(Correct_Text, 1, 11) & Mid(Correct_Text, 13, 2))
     If Len(Correct_Text) = "17" Then Correct_Text = (Mid(Correct_Text, 1, 11) & Mid(Correct_Text, 13, 5))
     AddOn_2 = ""
     AddOn_5 = ""
     AddOn_TextFinal = ""
     If Len(Correct_Text) = 16 Then AddOn_5 = Mid(Correct_Text, 12, 5)
     If Len(Correct_Text) = 13 Then AddOn_2 = Mid(Correct_Text, 12, 2)

     Text_Input = Mid(Correct_Text, 1, 11)
     
     Switch = 3
     PreCheckTotal = 0
     For I = Len(Text_Input) To 1 Step -1
          This_CharNum = Mid(Text_Input, I, 1)
          PreCheckTotal = PreCheckTotal + This_CharNum * Switch
          Switch = 4 - Switch
     Next I
     I = (PreCheckTotal Mod 10)
     If I <> 0 Then
          Check_Digit = (10 - I)
     Else
          Check_Digit = 0
     End If
     
     Text_Input = Text_Input & Check_Digit
     Dim D1 As String
     Dim D2 As String
     Dim D3 As String
     Dim D4 As String
     Dim D5 As String
     Dim D6 As String
     Dim D7 As String
     Dim D8 As String
     Dim D9 As String
     Dim D10 As String
     Dim D11 As String
     Dim D12 As String
     D1 = Mid(Text_Input, 1, 1)
     D2 = Mid(Text_Input, 2, 1)
     D3 = Mid(Text_Input, 3, 1)
     D4 = Mid(Text_Input, 4, 1)
     D5 = Mid(Text_Input, 5, 1)
     D6 = Mid(Text_Input, 6, 1)
     D7 = Mid(Text_Input, 7, 1)
     D8 = Mid(Text_Input, 8, 1)
     D9 = Mid(Text_Input, 9, 1)
     D10 = Mid(Text_Input, 10, 1)
     D11 = Mid(Text_Input, 11, 1)
     D12 = Mid(Text_Input, 12, 1)
     If (D11 = "5" Or D11 = "6" Or D11 = "7" Or D11 = "8" Or D11 = "9") And D6 <> "0" And (D7 = "0" And D8 = "0" And D9 = "0" And D10 = "0") Then
          Text_Input = D2 & D3 & D4 & D5 & D6 & D11
     End If
     If (D6 = "0" And D7 = "0" And D8 = "0" And D9 = "0" And D10 = "0") And D5 <> "0" Then
          Text_Input = D2 & D3 & D4 & D5 & D11 & "4"
     End If
     If (D5 = "0" And D6 = "0" And D7 = "0" And D8 = "0") And (D4 = "1" Or D4 = "2" Or D4 = "0") Then
          Text_Input = D2 & D3 & D9 & D10 & D11 & D4
     End If
     If (D5 = "0" And D6 = "0" And D7 = "0" And D8 = "0" And D9 = "0") And (D4 = "3" Or D4 = "4" Or D4 = "5" Or D4 = "6" Or D4 = "7" Or D4 = "8" Or D4 = "9") Then
          Text_Input = D2 & D3 & D4 & D10 & D11 & "3"
     End If
     If Len(Text_Input) = 6 Then
          Select Case D12
          Case "0"
               Enc_Method = "BBBAAA"
          Case "1"
               Enc_Method = "BBABAA"
          Case "2"
               Enc_Method = "BBAABA"
          Case "3"
               Enc_Method = "BBAAAB"
          Case "4"
               Enc_Method = "BABBAA"
          Case "5"
               Enc_Method = "BAABBA"
          Case "6"
               Enc_Method = "BAAABB"
          Case "7"
               Enc_Method = "BABABA"
          Case "8"
               Enc_Method = "BABAAB"
          Case "9"
               Enc_Method = "BAABAB"
          End Select
          Text_Len = Len(Text_Input)
          For I = 1 To Text_Len
               This_CharNum = AscW(Mid(Text_Input, I, 1))
               Current_Method = Mid(Enc_Method, I, 1)
               Select Case Current_Method
               Case "A"
                    Text_Output = Text_Output & ChrW(This_CharNum)
               Case "B"
                    Text_Output = Text_Output & ChrW(This_CharNum + 17)
               End Select
               Select Case I
               Case 1
                    Text_Output = ChrW(85) & "(" & Text_Output
               Case 6
                    If CInt(D12) > 4 Then Text_Output = Text_Output & ")" & ChrW(AscW(D12) + 64)
                    If CInt(D12) < 5 Then Text_Output = Text_Output & ")" & ChrW(AscW(D12) + 37)
                    
               End Select
          Next I
     End If
     
     If Len(Text_Input) <> 6 Then
          Text_Len = Len(Text_Input)
          For I = 1 To Text_Len
               This_CharNum = AscW(Mid(Text_Input, I, 1))
               Select Case I
               Case 1
                    If ChrW(This_CharNum) > 4 Then Text_Output = ChrW(This_CharNum + 64) & "(" & ChrW(This_CharNum + 49)
                    If ChrW(This_CharNum) < 5 Then Text_Output = ChrW(This_CharNum + 37) & "(" & ChrW(This_CharNum + 49)
               Case 2
                    Text_Output = Text_Output & ChrW(This_CharNum)
               Case 3
                    Text_Output = Text_Output & ChrW(This_CharNum)
               Case 4
                    Text_Output = Text_Output & ChrW(This_CharNum)
               Case 5
                    Text_Output = Text_Output & ChrW(This_CharNum)
               Case 6
                    Text_Output = Text_Output & ChrW(This_CharNum) & "*"
               Case 7
                    Text_Output = Text_Output & ChrW(This_CharNum + 27)
               Case 8
                    Text_Output = Text_Output & ChrW(This_CharNum + 27)
               Case 9
                    Text_Output = Text_Output & ChrW(This_CharNum + 27)
               Case 10
                    Text_Output = Text_Output & ChrW(This_CharNum + 27)
               Case 11
                    Text_Output = Text_Output & ChrW(This_CharNum + 27)
               Case 12
                    If ChrW(This_CharNum) > 4 Then Text_Output = Text_Output & ChrW(This_CharNum + 59) & "(" & ChrW(This_CharNum + 64)
                    If ChrW(This_CharNum) < 5 Then Text_Output = Text_Output & ChrW(This_CharNum + 59) & "(" & ChrW(This_CharNum + 37)
               End Select
          Next I
     End If
     
     If Len(AddOn_5) = 5 Then
          AddOn_TextFinal = ""
          Switch = 3
          PreCheckTotal = 0
          For I = Len(AddOn_5) To 1 Step -1
               This_CharNum = Mid(AddOn_5, I, 1)
               If Switch = 3 Then PreCheckTotal = PreCheckTotal + This_CharNum * 3
               If Switch = 1 Then PreCheckTotal = PreCheckTotal + This_CharNum * 9
               Switch = 4 - Switch
          Next I
          Check_Digit = Val(Right$(PreCheckTotal, 1))
          Select Case Check_Digit
          Case 0
               Enc_Method = "BBAAA"
          Case 1
               Enc_Method = "BABAA"
          Case 2
               Enc_Method = "BAABA"
          Case 3
               Enc_Method = "BAAAB"
          Case 4
               Enc_Method = "ABBAA"
          Case 5
               Enc_Method = "AABBA"
          Case 6
               Enc_Method = "AAABB"
          Case 7
               Enc_Method = "ABABA"
          Case 8
               Enc_Method = "ABAAB"
          Case 9
               Enc_Method = "AABAB"
          End Select
          
          For I = 1 To Len(AddOn_5)
               This_Char = Mid(AddOn_5, I, 1)
               Current_Method = Mid(Enc_Method, I, 1)
               Select Case Current_Method
               Case "A"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(34)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(35)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(36)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(37)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(38)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(44)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(46)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(47)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(58)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(59)
               Case "B"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(122)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(61)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(63)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(64)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(91)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(92)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(93)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(95)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(123)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(125)
               End Select
               Select Case I
               Case 1
                    AddOn_TextFinal = ChrW(43) & AddOn_TextFinal & ChrW(33)
               Case 2
                    AddOn_TextFinal = AddOn_TextFinal & ChrW(33)
               Case 3
                    AddOn_TextFinal = AddOn_TextFinal & ChrW(33)
               Case 4
                    AddOn_TextFinal = AddOn_TextFinal & ChrW(33)
               Case 5
                    AddOn_TextFinal = AddOn_TextFinal
               End Select
          Next I
     End If
     
     If Len(AddOn_2) = 2 Then
          AddOn_TextFinal = ""
          For I = 0 To 99 Step 4
               If Val(AddOn_2) = I Then Enc_Method = "AA"
               If Val(AddOn_2) = I + 1 Then Enc_Method = "AB"
               If Val(AddOn_2) = I + 2 Then Enc_Method = "BA"
               If Val(AddOn_2) = I + 3 Then Enc_Method = "BB"
          Next I
          For I = 1 To Len(AddOn_2)
               This_Char = Mid(AddOn_2, I, 1)
               Current_Method = Mid(Enc_Method, I, 1)
               Select Case Current_Method
               Case "A"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(34)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(35)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(36)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(37)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(38)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(44)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(46)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(47)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(58)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(59)
               Case "B"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(122)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(61)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(63)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(64)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(91)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(92)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(93)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(95)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(123)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(125)
               End Select
               Select Case I
               Case 1
                    AddOn_TextFinal = ChrW(43) & AddOn_TextFinal & ChrW(33)
               Case 2
                    AddOn_TextFinal = AddOn_TextFinal
               End Select
          Next I
     End If
     Printable_Text = Text_Output & AddOn_TextFinal & End_Sequence
     PrecisionID_UPC_E = Printable_Text
End Function

Public Function PrecisionID_EAN13(Text_Input As String) As String
     End_Sequence = "  "
     Text_Output = ""
     Text_Input = RTrim(LTrim(Text_Input))
     Correct_Text = ""
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
          If IsNumeric(Mid(Text_Input, I, 1)) Then Correct_Text = Correct_Text & Mid(Text_Input, I, 1)
     Next I
Text_Input = Correct_Text
     If Len(Correct_Text) < "12" Then Correct_Text = "0000000000000"
     If Len(Correct_Text) = "16" Then Correct_Text = "0000000000000"
     If Len(Correct_Text) = "13" Then Correct_Text = Mid(Correct_Text, 1, 12)
     If Len(Correct_Text) = "15" Then Correct_Text = (Mid(Correct_Text, 1, 12) & Mid(Correct_Text, 14, 2))
     If Len(Correct_Text) > "17" Then Correct_Text = (Mid(Correct_Text, 1, 12) & Mid(Correct_Text, 14, 5))

     Dim AddOn_2 As String
     Dim AddOn_5 As String
     Dim AddOn_TextFinal As String
     AddOn_2 = ""
     AddOn_5 = ""
     AddOn_TextFinal = ""
     If Len(Correct_Text) = 17 Then AddOn_5 = Mid(Correct_Text, 13, 5)
     If Len(Correct_Text) = 14 Then AddOn_2 = Mid(Correct_Text, 13, 2)
     Text_Input = Mid(Correct_Text, 1, 12)
     Switch = 3
     PreCheckTotal = 0
     For I = Len(Text_Input) To 1 Step -1
          This_CharNum = Mid(Text_Input, I, 1)
          PreCheckTotal = PreCheckTotal + This_CharNum * Switch
          Switch = 4 - Switch
     Next I
     I = (PreCheckTotal Mod 10)
     If I <> 0 Then
          Check_Digit = (10 - I)
     Else
          Check_Digit = 0
     End If
     Lead_Char = Mid(Text_Input, 1, 1)
     Select Case Lead_Char
     Case 0
          Enc_Method = "AAAAAACCCCCC"
     Case 1
          Enc_Method = "AABABBCCCCCC"
     Case 2
          Enc_Method = "AABBABCCCCCC"
     Case 3
          Enc_Method = "AABBBACCCCCC"
     Case 4
          Enc_Method = "ABAABBCCCCCC"
     Case 5
          Enc_Method = "ABBAABCCCCCC"
     Case 6
          Enc_Method = "ABBBAACCCCCC"
     Case 7
          Enc_Method = "ABABABCCCCCC"
     Case 8
          Enc_Method = "ABABBACCCCCC"
     Case 9
          Enc_Method = "ABBABACCCCCC"
     End Select
     Text_Input = Mid(Text_Input, 2, 11) & Check_Digit
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
          This_CharNum = AscW(Mid(Text_Input, I, 1))
          Current_Method = Mid(Enc_Method, I, 1)
          Select Case Current_Method
          Case "A"
               Text_Output = Text_Output & ChrW(This_CharNum)
          Case "B"
               Text_Output = Text_Output & ChrW(This_CharNum + 17)
          Case "C"
               Text_Output = Text_Output & ChrW(This_CharNum + 27)
          End Select
          Select Case I
          Case 1
               If Lead_Char > 4 Then Text_Output = ChrW((Lead_Char + 48) + 64) & "(" & Text_Output
               If Lead_Char < 5 Then Text_Output = ChrW((Lead_Char + 48) + 37) & "(" & Text_Output
          Case 6
               Text_Output = Text_Output & "*"
          Case 12
               Text_Output = Text_Output & "("
          End Select
     Next I
     If Len(AddOn_5) = 5 Then
          AddOn_TextFinal = ""
          Switch = 3
          PreCheckTotal = 0
          For I = Len(AddOn_5) To 1 Step -1
               This_CharNum = Mid(AddOn_5, I, 1)
               If Switch = 3 Then PreCheckTotal = PreCheckTotal + This_CharNum * 3
               If Switch = 1 Then PreCheckTotal = PreCheckTotal + This_CharNum * 9
               Switch = 4 - Switch
          Next I
          Check_Digit = Val(Right$(PreCheckTotal, 1))
          Select Case Check_Digit
          Case 0
               Enc_Method = "BBAAA"
          Case 1
               Enc_Method = "BABAA"
          Case 2
               Enc_Method = "BAABA"
          Case 3
               Enc_Method = "BAAAB"
          Case 4
               Enc_Method = "ABBAA"
          Case 5
               Enc_Method = "AABBA"
          Case 6
               Enc_Method = "AAABB"
          Case 7
               Enc_Method = "ABABA"
          Case 8
               Enc_Method = "ABAAB"
          Case 9
               Enc_Method = "AABAB"
          End Select
          For I = 1 To Len(AddOn_5)
               This_Char = Mid(AddOn_5, I, 1)
               Current_Method = Mid(Enc_Method, I, 1)
               Select Case Current_Method
               Case "A"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(34)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(35)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(36)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(37)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(38)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(44)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(46)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(47)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(58)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(59)
               Case "B"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(122)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(61)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(63)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(64)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(91)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(92)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(93)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(95)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(123)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(125)
               End Select
               Select Case I
               Case 1
                    AddOn_TextFinal = ChrW(32) & ChrW(43) & AddOn_TextFinal & ChrW(33)
               Case 2
                    AddOn_TextFinal = AddOn_TextFinal & ChrW(33)
               Case 3
                    AddOn_TextFinal = AddOn_TextFinal & ChrW(33)
               Case 4
                    AddOn_TextFinal = AddOn_TextFinal & ChrW(33)
               Case 5
                    AddOn_TextFinal = AddOn_TextFinal
               End Select
          Next I
     End If
     If Len(AddOn_2) = 2 Then
          AddOn_TextFinal = ""
          For I = 0 To 99 Step 4
               If Val(AddOn_2) = I Then Enc_Method = "AA"
               If Val(AddOn_2) = I + 1 Then Enc_Method = "AB"
               If Val(AddOn_2) = I + 2 Then Enc_Method = "BA"
               If Val(AddOn_2) = I + 3 Then Enc_Method = "BB"
          Next I
          For I = 1 To Len(AddOn_2)
               This_Char = Mid(AddOn_2, I, 1)
               Current_Method = Mid(Enc_Method, I, 1)
               Select Case Current_Method
               Case "A"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(34)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(35)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(36)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(37)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(38)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(44)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(46)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(47)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(58)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(59)
               Case "B"
                    If This_Char = "0" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(122)
                    If This_Char = "1" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(61)
                    If This_Char = "2" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(63)
                    If This_Char = "3" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(64)
                    If This_Char = "4" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(91)
                    If This_Char = "5" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(92)
                    If This_Char = "6" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(93)
                    If This_Char = "7" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(95)
                    If This_Char = "8" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(123)
                    If This_Char = "9" Then AddOn_TextFinal = AddOn_TextFinal & ChrW(125)
               End Select
               Select Case I
               Case 1
                    AddOn_TextFinal = ChrW(32) & ChrW(43) & AddOn_TextFinal & ChrW(33)
               Case 2
                    AddOn_TextFinal = AddOn_TextFinal
               End Select
          Next I
     End If
     Printable_Text = Text_Output & AddOn_TextFinal & End_Sequence
     PrecisionID_EAN13 = Printable_Text
End Function


Public Function PrecisionID_EAN8(Text_Input As String) As String
     End_Sequence = "  "
     Text_Output = ""
     Text_Input = RTrim(LTrim(Text_Input))
     Correct_Text = ""
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
          If IsNumeric(Mid(Text_Input, I, 1)) Then Correct_Text = Correct_Text & Mid(Text_Input, I, 1)
     Next I
     Text_Input = Correct_Text
     
     If Len(Correct_Text) > "7" Then Correct_Text = Mid(Correct_Text, 1, 7)
     If Len(Correct_Text) < "7" Then Correct_Text = "0000000"
     Text_Input = Correct_Text
     Switch = 3
     PreCheckTotal = 0
     For I = Len(Text_Input) To 1 Step -1
          This_CharNum = Mid(Text_Input, I, 1)
          PreCheckTotal = PreCheckTotal + This_CharNum * Switch
          Switch = 4 - Switch
     Next I
     I = (PreCheckTotal Mod 10)
     If I <> 0 Then
          Check_Digit = (10 - I)
     Else
          Check_Digit = 0
     End If
     Text_Input = Text_Input & Check_Digit
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
          This_CharNum = AscW(Mid(Text_Input, I, 1))
          Current_Method = Mid(Enc_Method, I, 1)
          Select Case I
          Case 1
               Text_Output = "(" & ChrW(This_CharNum)
          Case 2
               Text_Output = Text_Output & ChrW(This_CharNum)
          Case 3
               Text_Output = Text_Output & ChrW(This_CharNum)
          Case 4
               Text_Output = Text_Output & ChrW(This_CharNum) & "*"
          Case 5
               Text_Output = Text_Output & ChrW(This_CharNum + 27)
          Case 6
               Text_Output = Text_Output & ChrW(This_CharNum + 27)
          Case 7
               Text_Output = Text_Output & ChrW(This_CharNum + 27)
          Case 8
               Text_Output = Text_Output & ChrW(This_CharNum + 27) & "("
          End Select
     Next I
     Printable_Text = Text_Output & End_Sequence
     PrecisionID_EAN8 = Printable_Text
End Function



Public Function PrecisionID_MOD10(Text_Input As String) As String
     Correct_Text = ""
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
          If IsNumeric(Mid(Text_Input, I, 1)) Then Correct_Text = Correct_Text & Mid(Text_Input, I, 1)
     Next I
     Switch = 3
     PreCheckTotal = 0
     Text_Len = Len(Text_Input)
     For I = Text_Len To 1 Step -1
          This_CharNum = Mid(Text_Input, I, 1)
          PreCheckTotal = PreCheckTotal + This_CharNum * Switch
          Switch = 4 - Switch
     Next I
     I = (PreCheckTotal Mod 10)
     If I <> 0 Then
          Check_Digit = (10 - I)
     Else
          Check_Digit = 0
     End If
     MOD10 = Str(Check_Digit)
End Function





